package jp.mosp.payroll.payment.action;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.kintai.payroll.dao.KdWorkDao;
import jp.mosp.kintai.payroll.dto.KdWorkDto;
import jp.mosp.payroll.base.PayrollAction;
import jp.mosp.payroll.base.PayrollConst;
import jp.mosp.payroll.dao.MKintaiDao;
import jp.mosp.payroll.dao.PiPaymentDao;
import jp.mosp.payroll.dto.DetailTimeDto;
import jp.mosp.payroll.dto.MKintaiDto;
import jp.mosp.payroll.payment.vo.ImportTimeVo;

/**
 * 勤怠データ取込画面における処理を行う。<br><br>
 * 以下のコマンドを扱う。
 * <ul><li>
 * {@link #CMD_SHOW}
 * </li><li>
 * {@link #CMD_EXECUTE}
 * </li></ul>
 */
public class ImportTimeAction extends PayrollAction {
	
	/**
	 * 画面表示コマンド。<br><br>
	 * 給与計算中の年月を取得、表示する。<br>
	 * もし給与計算中の年月がなかった場合は、警告する。<br>
	 * 給与計算中の年月における中間データが存在した場合も、警告する。<br>
	 */
	public static final String	CMD_SHOW	= "P1220";
	
	/**
	 * 処理実行コマンド。<br><br>
	 * 表示された計算年月に対して、MosP勤怠管理から勤怠データを取込む。<br>
	 * 計算年月における中間データが存在している場合、それらは削除される。<br>
	 */
	public static final String	CMD_EXECUTE	= "P1225";
	

	/**
	 * Actionの初期化を行う。<br><br>
	 * 以下の処理を行う。
	 * <ul><li>
	 * {@link PayrollAction#PayrollAction()}
	 * </li></ul>
	 */
	public ImportTimeAction() {
		super();
	}
	
	/* (non-Javadoc)
	 * @see jp.mosp.common.common.BaseAction#getSpecificVo()
	 */
	@Override
	protected BaseVo getSpecificVo() {
		return new ImportTimeVo();
	}
	
	/**
	 * アクション。<br>
	 * 詳細は、クラス説明を参照。<br>
	 */
	public void action() throws Exception {
		// VO取得及び設定
		prepareVo();
		if (cmd.equals(CMD_SHOW)) {
			// 画面表示
			show();
		} else if (cmd.equals(CMD_EXECUTE)) {
			// 処理実行
			execute();
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
	/**
	 * 画面表示処理を行う。<br>
	 * @throws Exception 例外処理が発生した場合
	 */
	@Override
	public void show() throws Exception {
		// コネクション取得
		getConnection();
		// VO取得
		ImportTimeVo vo = (ImportTimeVo)getVo();
		// 計算中情報取得
		Date current = getCurrent(PayrollConst.OFFICE_ALL, PayrollConst.CALC_PAYMENT);
		// 計算中情報確認
		if (current == null) {
			// 画面モード設定
			vo.setMode(1);
			// 警告メッセージ設定
			vo.addErrMessage(MospUtility.getMessage(msg, "WP1210", ""));
			// 例外スロー
			throw new MospException(MospConst.EX_PARAMS_INVALID);
		}
		// 中間データ存在確認
		List<DetailTimeDto> list = new PiPaymentDao(cfg, cmd, aspUser, user, conn).find(current);
		if (list.size() > 0) {
			// 警告メッセージ設定
			vo.addErrMessage(MospUtility.getMessage(msg, "WP1220", MospUtility.getDateString(current,
					PayrollConst.FORMAT_YEAR_MONTH)
					+ MospConst.DATA_SEPARATOR + vo.getName("P_INTERFACE")));
		}
		// VOフィールド設定
		vo.setCalcDate(current);
		// 画面モード設定
		vo.setMode(0);
	}
	
	/**
	 * 勤怠データ取込処理を行う。<br>
	 * @throws Exception 例外処理が発生した場合
	 */
	private void execute() throws Exception {
		// コネクション取得
		getConnection();
		// VO取得
		ImportTimeVo vo = (ImportTimeVo)getVo();
		// 対象年月取得
		Date targetMonth = vo.getCalcDate();
		// 計算月確認
		if (!isCurrent(targetMonth, PayrollConst.OFFICE_ALL, PayrollConst.CALC_PAYMENT)) {
			// メッセージ設定
			addErrMessage(MospUtility.getMessage(msg, "WP1211", ""));
			return;
		}
		// 取込処理
		importTime();
		// メッセージ設定
		setMessage(MospUtility.getMessage(msg, "IP1220", MospUtility.getDateString(vo.getCalcDate(),
				PayrollConst.FORMAT_YEAR_MONTH)));
		// 次コマンド設定(給与計算画面へ)
		setNextCmd(CalcPaymentAction.CMD_SHOW);
	}
	
	/**
	 * 勤怠管理システムから勤怠データを取り込む。<br>
	 * @throws NoSuchFieldException フィールドが見つからなかった場合
	 * @throws IllegalAccessException メソッドにアクセスできない場合
	 * @throws SQLException SQL例外が発生した場合
	 */
	private void importTime() throws SQLException, IllegalAccessException, NoSuchFieldException {
		// VO取得
		ImportTimeVo vo = (ImportTimeVo)getVo();
		// 対象年月取得
		Date targetMonth = vo.getCalcDate();
		// 勤怠管理システムDAO準備
		KdWorkDao dao = new KdWorkDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// 勤怠管理システムデータ取得
		List<KdWorkDto> list = dao.findForExport(MospUtility.getDateString(targetMonth, PayrollConst.FORMAT_FOR_TIME));
		// 登録データ準備
		List<DetailTimeDto> listTime = new ArrayList<DetailTimeDto>();
		if (list.size() > 0) {
			for (KdWorkDto dto : list) {
				// 給与中間データ作成
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_SNEN));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_STUKI));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_SHI));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_SNISSU));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_SKAISU));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_KINMUJI));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_KYUKEIJI));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_YUKYU));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_TOKUKYU));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_KEKKIN));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_SKEKKIN));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_DAIKYU));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_FURIKAE));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_SONOTA));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_TISOKAI));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_TIJIKAN));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_ZAJIKAN));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_KSJIKAN));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_SNJIKAN));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_KAIKIN));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_SYOKUJIKAISU));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_CYOKUKAISU1));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_CYOKUKAISU2));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_CYOKUKAISU3));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_HOKAKAISU1));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_HOKAKAISU2));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_HOKAKAISU3));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_HOKAKAISU4));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_HOKAKAISU5));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_SINSEIGAKU));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_NIJIKYU));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_WARIMASI1));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_KKRIYUU6));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_KKRIYUU7));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_KKRIYUU8));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_KKRIYUU9));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_WEEK_DAY_OVRE_TIME));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_WEEK_HOLIDAY_OVRE_TIME));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_LIMIT_OVRE_TIME));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_MONTHLY_OVRE_TIME));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_MONTHLY_WEEK_HOLIDAY));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_HOUR_HOLIDAY));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_SUBSTITUTE_HOLIDAY));
				listTime.add(makeTimeDetail(dto, targetMonth, PayrollConst.DTL_AMEND_FLAG));
			}
		} else {
			// 勤怠管理システムDAO準備
			MKintaiDao daoKintai = new MKintaiDao();
			daoKintai.initDao(cfg, cmd, aspUser, user, conn);
			// 勤怠管理システムデータ取得
			List<MKintaiDto> listKintai = daoKintai.findForExport(MospUtility.getDateString(targetMonth,
					PayrollConst.FORMAT_FOR_TIME));
			for (MKintaiDto dtoKintai : listKintai) {
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_SNEN));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_STUKI));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_SHI));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_SNISSU));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_SKAISU));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_KINMUJI));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_KYUKEIJI));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_YUKYU));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_TOKUKYU));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_KEKKIN));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_SKEKKIN));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_DAIKYU));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_FURIKAE));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_SONOTA));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_TISOKAI));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_TIJIKAN));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_ZAJIKAN));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_KSJIKAN));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_SNJIKAN));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_KAIKIN));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_SYOKUJIKAISU));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_CYOKUKAISU1));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_CYOKUKAISU2));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_CYOKUKAISU3));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_HOKAKAISU1));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_HOKAKAISU2));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_HOKAKAISU3));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_HOKAKAISU4));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_HOKAKAISU5));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_SINSEIGAKU));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_NIJIKYU));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_WARIMASI1));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_KKRIYUU6));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_KKRIYUU7));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_KKRIYUU8));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_KKRIYUU9));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_WEEK_DAY_OVRE_TIME));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_WEEK_HOLIDAY_OVRE_TIME));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_LIMIT_OVRE_TIME));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_MONTHLY_OVRE_TIME));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_MONTHLY_WEEK_HOLIDAY));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_HOUR_HOLIDAY));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_SUBSTITUTE_HOLIDAY));
				listTime.add(makeTimeDetail(dtoKintai, targetMonth, PayrollConst.DTL_AMEND_FLAG));
			}
		}
		// 給与計算システムDAO準備
		PiPaymentDao ptPaymentDao = new PiPaymentDao(cfg, cmd, aspUser, user, conn);
		// 対象年月データ削除
		ptPaymentDao.delete(targetMonth);
		// 登録
		ptPaymentDao.insert(listTime);
		// コミット
		commit();
	}
	
	/**
	 * 勤怠管理システムデータを変換する。
	 * @param dto         勤怠管理システムデータ
	 * @param targetMonth 対象年月
	 * @param detailCode  明細コード
	 * @return 給与計算システムデータ
	 */
	private DetailTimeDto makeTimeDetail(KdWorkDto dto, Date targetMonth, String detailCode) {
		DetailTimeDto detailDto = new DetailTimeDto();
		detailDto.setKCode(dto.getKCode());
		detailDto.setCalcDate(targetMonth);
		detailDto.setDetailCode(detailCode);
		if (detailCode.equals(PayrollConst.DTL_SNEN)) {
			// 支給年
			detailDto.setAmount(dto.getSNen());
		} else if (detailCode.equals(PayrollConst.DTL_STUKI)) {
			// 支給月
			detailDto.setAmount(dto.getSTuki());
		} else if (detailCode.equals(PayrollConst.DTL_SHI)) {
			// 支給日
			detailDto.setAmount(dto.getSHi());
		} else if (detailCode.equals(PayrollConst.DTL_SNISSU)) {
			// 出勤日数
			detailDto.setAmount((float)dto.getSNissu());
		} else if (detailCode.equals(PayrollConst.DTL_SKAISU)) {
			// 出勤回数
			detailDto.setAmount(dto.getSKaisu());
		} else if (detailCode.equals(PayrollConst.DTL_KINMUJI)) {
			// 勤務時間
			detailDto.setAmount(dto.getKinmuJi());
		} else if (detailCode.equals(PayrollConst.DTL_KYUKEIJI)) {
			// 休憩時間
			detailDto.setAmount(dto.getKyukeiJi());
		} else if (detailCode.equals(PayrollConst.DTL_YUKYU)) {
			// 有休
			detailDto.setAmount((float)dto.getYukyu());
		} else if (detailCode.equals(PayrollConst.DTL_TOKUKYU)) {
			// 特別休暇
			detailDto.setAmount((float)dto.getTokukyu());
		} else if (detailCode.equals(PayrollConst.DTL_KEKKIN)) {
			// 一般欠勤日数
			detailDto.setAmount((float)dto.getKekkin());
		} else if (detailCode.equals(PayrollConst.DTL_SKEKKIN)) {
			// 傷病欠勤日数
			detailDto.setAmount((float)dto.getSKekkin());
		} else if (detailCode.equals(PayrollConst.DTL_DAIKYU)) {
			// 代替休暇
			detailDto.setAmount((float)dto.getDaikyu());
		} else if (detailCode.equals(PayrollConst.DTL_FURIKAE)) {
			// 振替休暇
			detailDto.setAmount((float)dto.getFurikae());
		} else if (detailCode.equals(PayrollConst.DTL_SONOTA)) {
			// その他休暇
			detailDto.setAmount((float)dto.getSonota());
		} else if (detailCode.equals(PayrollConst.DTL_TISOKAI)) {
			// 遅刻早退回数
			detailDto.setAmount(dto.getTiSoKai());
		} else if (detailCode.equals(PayrollConst.DTL_TIJIKAN)) {
			// 遅刻早退時間
			detailDto.setAmount(dto.getTiSoJikan());
		} else if (detailCode.equals(PayrollConst.DTL_ZAJIKAN)) {
			// 普通残業時間
			detailDto.setAmount(dto.getZaJikan());
		} else if (detailCode.equals(PayrollConst.DTL_KSJIKAN)) {
			// 休日出勤時間
			detailDto.setAmount(dto.getKsJikan());
		} else if (detailCode.equals(PayrollConst.DTL_SNJIKAN)) {
			// 深夜勤務時間
			detailDto.setAmount(dto.getSnJikan());
		} else if (detailCode.equals(PayrollConst.DTL_KAIKIN)) {
			// 精皆勤手当支給
			detailDto.setAmount(dto.getKaikin());
		} else if (detailCode.equals(PayrollConst.DTL_SYOKUJIKAISU)) {
			// 食事手当支給回数
			detailDto.setAmount(dto.getSyokujiKaisu());
		} else if (detailCode.equals(PayrollConst.DTL_CYOKUKAISU1)) {
			// 1直手当支給回数
			detailDto.setAmount(dto.getCyokuKaisu1());
		} else if (detailCode.equals(PayrollConst.DTL_CYOKUKAISU2)) {
			// 2直手当支給回数
			detailDto.setAmount(dto.getCyokuKaisu2());
		} else if (detailCode.equals(PayrollConst.DTL_CYOKUKAISU3)) {
			// 3直手当支給回数
			detailDto.setAmount(dto.getCyokuKaisu3());
		} else if (detailCode.equals(PayrollConst.DTL_HOKAKAISU1)) {
			// その他支給回数1
			detailDto.setAmount(dto.getHokaKaisu1());
		} else if (detailCode.equals(PayrollConst.DTL_HOKAKAISU2)) {
			// その他支給回数2
			detailDto.setAmount(dto.getHokaKaisu2());
		} else if (detailCode.equals(PayrollConst.DTL_HOKAKAISU3)) {
			// その他支給回数3
			detailDto.setAmount(dto.getHokaKaisu3());
		} else if (detailCode.equals(PayrollConst.DTL_HOKAKAISU4)) {
			// その他支給回数4
			detailDto.setAmount(dto.getHokaKaisu4());
		} else if (detailCode.equals(PayrollConst.DTL_HOKAKAISU5)) {
			// その他支給回数5
			detailDto.setAmount(dto.getHokaKaisu5());
		} else if (detailCode.equals(PayrollConst.DTL_SINSEIGAKU)) {
			// 支払申請額
			detailDto.setAmount(dto.getSinseiGaku());
		} else if (detailCode.equals(PayrollConst.DTL_WARIMASI1)) {
			// 1.00割増
			detailDto.setAmount(dto.getWarimasi1());
		} else if (detailCode.equals(PayrollConst.DTL_KKRIYUU6)) {
			// 休暇理由6
			detailDto.setAmount((float)dto.getKkRiyuu6());
		} else if (detailCode.equals(PayrollConst.DTL_KKRIYUU7)) {
			// 休暇理由7
			detailDto.setAmount((float)dto.getKkRiyuu7());
		} else if (detailCode.equals(PayrollConst.DTL_KKRIYUU8)) {
			// 休暇理由8
			detailDto.setAmount((float)dto.getKkRiyuu8());
		} else if (detailCode.equals(PayrollConst.DTL_KKRIYUU9)) {
			// 休暇理由8
			detailDto.setAmount((float)dto.getKkRiyuu9());
		} else if (detailCode.equals(PayrollConst.DTL_WEEK_DAY_OVRE_TIME)) {
			// 平日時間外
			detailDto.setAmount(dto.getWeekDayOverTime());
		} else if (detailCode.equals(PayrollConst.DTL_WEEK_HOLIDAY_OVRE_TIME)) {
			// 所定休日時間外
			detailDto.setAmount(dto.getWeekHolidayOverTime());
		} else if (detailCode.equals(PayrollConst.DTL_MONTHLY_OVRE_TIME)) {
			// 月60時間超過平日時間外
			detailDto.setAmount(dto.getMonthlyOverTime());
		} else if (detailCode.equals(PayrollConst.DTL_MONTHLY_WEEK_HOLIDAY)) {
			// 月60時間超過所定休日時間外
			detailDto.setAmount(dto.getMonthlyWeekHoliday());
		} else if (detailCode.equals(PayrollConst.DTL_HOUR_HOLIDAY)) {
			// 時間外単位年休取得時間 
			detailDto.setAmount(dto.getHourHoliday());
		} else if (detailCode.equals(PayrollConst.DTL_SUBSTITUTE_HOLIDAY)) {
			// 時間外時間代替休暇取得日数
			detailDto.setAmount((float)dto.getSubstituteHoliday());
		} else if (detailCode.equals(PayrollConst.DTL_AMEND_FLAG)) {
			// 修正フラグ
			detailDto.setAmount((float)dto.getKkRiyuu9());
		} else {
			detailDto.setAmount(0F);
		}
		return detailDto;
	}
	
	/**
	 * 勤怠管理システムデータを変換する。
	 * @param dto         勤怠管理システムデータ
	 * @param targetMonth 対象年月
	 * @param detailCode  明細コード
	 * @return 給与計算システムデータ
	 */
	private DetailTimeDto makeTimeDetail(MKintaiDto dto, Date targetMonth, String detailCode) {
		DetailTimeDto detailDto = new DetailTimeDto();
		detailDto.setKCode(dto.getKCode());
		detailDto.setCalcDate(targetMonth);
		detailDto.setDetailCode(detailCode);
		if (detailCode.equals(PayrollConst.DTL_SNEN)) {
			detailDto.setAmount(dto.getSNen());
		} else if (detailCode.equals(PayrollConst.DTL_STUKI)) {
			detailDto.setAmount(dto.getSTuki());
		} else if (detailCode.equals(PayrollConst.DTL_SHI)) {
			detailDto.setAmount(dto.getSHi());
		} else if (detailCode.equals(PayrollConst.DTL_SNISSU)) {
			detailDto.setAmount((float)dto.getSNissu());
		} else if (detailCode.equals(PayrollConst.DTL_SKAISU)) {
			detailDto.setAmount(dto.getSKaisu());
		} else if (detailCode.equals(PayrollConst.DTL_KINMUJI)) {
			detailDto.setAmount(dto.getKinmuJi());
		} else if (detailCode.equals(PayrollConst.DTL_KYUKEIJI)) {
			detailDto.setAmount(dto.getKyukeiJi());
		} else if (detailCode.equals(PayrollConst.DTL_YUKYU)) {
			detailDto.setAmount((float)dto.getYukyu());
		} else if (detailCode.equals(PayrollConst.DTL_TOKUKYU)) {
			detailDto.setAmount((float)dto.getTokuKyu());
		} else if (detailCode.equals(PayrollConst.DTL_KEKKIN)) {
			detailDto.setAmount((float)dto.getKekkin());
		} else if (detailCode.equals(PayrollConst.DTL_SKEKKIN)) {
			detailDto.setAmount((float)dto.getSKekkin());
		} else if (detailCode.equals(PayrollConst.DTL_DAIKYU)) {
			detailDto.setAmount((float)dto.getDaiKyu());
		} else if (detailCode.equals(PayrollConst.DTL_FURIKAE)) {
			detailDto.setAmount((float)dto.getFurikae());
		} else if (detailCode.equals(PayrollConst.DTL_SONOTA)) {
			detailDto.setAmount(dto.getSonota());
		} else if (detailCode.equals(PayrollConst.DTL_TISOKAI)) {
			detailDto.setAmount(dto.getTiSoKai());
		} else if (detailCode.equals(PayrollConst.DTL_TIJIKAN)) {
			detailDto.setAmount(dto.getTiJikan());
		} else if (detailCode.equals(PayrollConst.DTL_ZAJIKAN)) {
			detailDto.setAmount(dto.getZaJikan());
		} else if (detailCode.equals(PayrollConst.DTL_KSJIKAN)) {
			detailDto.setAmount(dto.getKsJikan());
		} else if (detailCode.equals(PayrollConst.DTL_SNJIKAN)) {
			detailDto.setAmount(dto.getSnJikan());
		} else if (detailCode.equals(PayrollConst.DTL_KAIKIN)) {
			detailDto.setAmount(dto.getKaikin());
		} else if (detailCode.equals(PayrollConst.DTL_SYOKUJIKAISU)) {
			detailDto.setAmount(dto.getSyokujiKaisu());
		} else if (detailCode.equals(PayrollConst.DTL_CYOKUKAISU1)) {
			detailDto.setAmount(dto.getCyokuKaisu1());
		} else if (detailCode.equals(PayrollConst.DTL_CYOKUKAISU2)) {
			detailDto.setAmount(dto.getCyokuKaisu2());
		} else if (detailCode.equals(PayrollConst.DTL_CYOKUKAISU3)) {
			detailDto.setAmount(dto.getCyokuKaisu3());
		} else if (detailCode.equals(PayrollConst.DTL_HOKAKAISU1)) {
			detailDto.setAmount(dto.getHokaKaisu1());
		} else if (detailCode.equals(PayrollConst.DTL_HOKAKAISU2)) {
			detailDto.setAmount(dto.getHokaKaisu2());
		} else if (detailCode.equals(PayrollConst.DTL_HOKAKAISU3)) {
			detailDto.setAmount(dto.getHokaKaisu3());
		} else if (detailCode.equals(PayrollConst.DTL_HOKAKAISU4)) {
			detailDto.setAmount(dto.getHokaKaisu4());
		} else if (detailCode.equals(PayrollConst.DTL_HOKAKAISU5)) {
			detailDto.setAmount(dto.getHokaKaisu5());
		} else if (detailCode.equals(PayrollConst.DTL_SINSEIGAKU)) {
			detailDto.setAmount(dto.getSinseiGaku());
		} else if (detailCode.equals(PayrollConst.DTL_NIJIKYU)) {
			detailDto.setAmount(dto.getNijiKyu());
		} else if (detailCode.equals(PayrollConst.DTL_WARIMASI1)) {
			detailDto.setAmount(dto.getWarimasi1());
		} else {
			detailDto.setAmount(0F);
		}
		return detailDto;
	}
	
}
